package org.lsh.webservice.ui.common;

/** return body define
 * @author leishihua
 * @param <T>
 */
public class Result<T> {

    private int code;
    private T data;
    private String msg;

    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    public T getData() {
        return data;
    }

    public void setData(T data) {
        this.data = data;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }


    public static <T> Result<T> ok() {
        return restResult(null, CommonConstants.SUCCESS.getValue(), "success");
    }

    public static <T> Result<T> ok(T data) {
        return restResult(data, CommonConstants.SUCCESS.getValue(), null);
    }

    public static <T> Result<T> ok(T data, String msg) {
        return restResult(data, CommonConstants.SUCCESS.getValue(), msg);
    }

    public static <T> Result<T> failed() {
        return restResult(null, CommonConstants.FAIL.getValue(), null);
    }

    public static <T> Result<T> failed(String msg) {
        return restResult(null, CommonConstants.FAIL.getValue(), msg);
    }

    public static <T> Result<T> failed(T data) {
        return restResult(data, CommonConstants.FAIL.getValue(), null);
    }

    public static <T> Result<T> failed(T data, String msg) {
        return restResult(data, CommonConstants.FAIL.getValue(), msg);
    }

    private static <T> Result<T> restResult(T data, int code, String msg) {
        Result<T> apiResult = new Result<>();
        apiResult.setCode(code);
        apiResult.setData(data);
        apiResult.setMsg(msg);
        return apiResult;
    }
}
