package org.lsh.webservice.ui.mapper;

import org.apache.ibatis.annotations.*;
import org.lsh.webservice.ui.entity.tree.Operation;

import java.util.List;

@Mapper
public interface OperationMapper {

    @Insert("INSERT INTO OPERATION (NAME, WEBSERVICE_ID,INPUT,OUTPUT) VALUES(#{operation.name}, #{operation.webserviceId}, #{operation.input}, #{operation.output});")
    int insert(@Param("operation")Operation operation);

    @Select("select * from operation where webservice_id=#{webserviceId}")
    @Results({
            @Result(property = "name", column = "name"), // 指定属性名和列名的映射关系
            @Result(property = "webserviceId", column = "webservice_id"), // 指定属性名和列名的映射关系
    })
    List<Operation> findByWebserviceId(Integer webserviceId);

    @Select("select * from operation where id=#{id}")
    @Results({
            @Result(property = "name", column = "name"), // 指定属性名和列名的映射关系
            @Result(property = "webserviceId", column = "webservice_id"), // 指定属性名和列名的映射关系
    })
    Operation findById(Integer id);
}
