package org.lsh.webservice.ui.mapper;

import org.apache.ibatis.annotations.*;
import org.lsh.webservice.ui.entity.dto.ServerInfo;
import org.lsh.webservice.ui.entity.tree.Project;
import org.lsh.webservice.ui.entity.tree.Webservice;

import java.util.List;

@Mapper
public interface WebserviceMapper {

    @Insert("INSERT INTO WEBSERVICE (NAME, WSDL, PROJECT_ID) VALUES(#{webservice.name}, #{webservice.wsdl}, #{webservice.projectId})")
    @Options(useGeneratedKeys = true, keyProperty = "id")
    int insert(@Param("webservice") Webservice webservice);

    @Select("select * from webservice where project_id=#{projectId}")
    @Results({
            @Result(property = "name", column = "name"), // 指定属性名和列名的映射关系
            @Result(property = "projectId", column = "PROJECT_ID"), // 指定属性名和列名的映射关系
    })
    List<Webservice> findByProjectId(Integer projectId);

    @Select("select * from webservice where id=#{id}")
    @Results({
            @Result(property = "name", column = "name"), // 指定属性名和列名的映射关系
            @Result(property = "projectId", column = "PROJECT_ID"), // 指定属性名和列名的映射关系
    })
    Webservice findById(Integer id);

}
