package org.lsh.webservice.ui.utils;

import cn.hutool.core.collection.CollectionUtil;
import org.lsh.webservice.ui.entity.FormField;

import java.lang.reflect.Array;
import java.lang.reflect.Field;
import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Type;
import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;

public class ExplainField {

    public static void explain(Object o,Field declaredField, List<FormField> formFieldList) throws ClassNotFoundException, IllegalAccessException {
        // 集合
        FormField complexType = new FormField();
        Object currentValue = null;
        if(o != null){
            declaredField.setAccessible(true);
            currentValue = declaredField.get(o);
            complexType.setValue(currentValue);
        }
        // 判断Field类型
        if(declaredField.getType() == List.class || declaredField.getType() == Array.class){
            // 获取List的泛型类型
            Type genericType = declaredField.getGenericType();
            if(genericType instanceof ParameterizedType){
                ParameterizedType parameterizedType = (ParameterizedType)genericType;
                Type[] actualTypeArguments = parameterizedType.getActualTypeArguments();
                if(actualTypeArguments.length>0){
                    complexType.setFieldName(declaredField.getName());
                    complexType.setTypeName(declaredField.getType().getTypeName());

                    List<FormField> formFields = new ArrayList<>();
                    complexType.setFields(formFields);
                    // 获取List的泛型类型
                    Type actualTypeArgument = actualTypeArguments[0];
                    Class classes = (Class) actualTypeArgument;
                    // 泛型类加载器
                    if(classes != null) {
                        complexType.setGenericType(classes.getTypeName());
                        if(currentValue != null){
                            List<?> list = (List)currentValue;
                            if(CollectionUtil.isEmpty(list)){
                                currentValue = null;
                                // 集合第一个对象
                                FormField firstObj = new FormField();
                                firstObj.setFieldName("0");
                                firstObj.setTypeName(classes.getTypeName());
                                formFields.add(firstObj);

                                List<FormField> firstObjFields = new ArrayList<>();
                                firstObj.setFields(firstObjFields);
                                Field[] declaredFields2 = classes.getDeclaredFields();
                                for (Field declaredField2 : declaredFields2) {
                                    explain(currentValue,declaredField2, firstObjFields);
                                }
                            }else{
                                for (int i = 0; i < list.size(); i++) {
                                    Object o1 = list.get(i);
                                    // 集合第一个对象
                                    FormField firstObj = new FormField();
                                    firstObj.setFieldName(i+"");
                                    firstObj.setTypeName(classes.getTypeName());
                                    formFields.add(firstObj);

                                    List<FormField> firstObjFields = new ArrayList<>();
                                    firstObj.setFields(firstObjFields);
                                    Field[] declaredFields2 = classes.getDeclaredFields();
                                    for (Field declaredField2 : declaredFields2) {
                                        explain(o1,declaredField2, firstObjFields);
                                    }
                                }
                            }
                        }else{
                            // 集合第一个对象
                            FormField firstObj = new FormField();
                            firstObj.setFieldName("0");
                            firstObj.setTypeName(classes.getTypeName());
                            formFields.add(firstObj);

                            List<FormField> firstObjFields = new ArrayList<>();
                            firstObj.setFields(firstObjFields);
                            Field[] declaredFields2 = classes.getDeclaredFields();
                            for (Field declaredField2 : declaredFields2) {
                                explain(currentValue,declaredField2, firstObjFields);
                            }
                        }
                    }
                    formFieldList.add(complexType);
                }
            }
        }else if(
            declaredField.getType() == String.class
            || declaredField.getType() == Integer.class
            || declaredField.getType() == Double.class
            || declaredField.getType() == java.util.Date.class
            || declaredField.getType() == Boolean.class
            || declaredField.getType() == Long.class
            || declaredField.getType() == BigDecimal.class
            || declaredField.getType() == LocalDateTime.class
            || declaredField.getType() == LocalDate.class
            || declaredField.getType().getTypeName().equals("int")
            || declaredField.getType().getTypeName().equals("long")){

            complexType.setFieldName(declaredField.getName());
            complexType.setTypeName(declaredField.getType().getTypeName());
            formFieldList.add(complexType);

        }else {
            // 自定义的数据类型
            System.out.println("进入自定义数据类型：" + declaredField.getName() + "====" + declaredField.getType());
            // 获取该字段的参数类型
            Class class2 = (Class)declaredField.getGenericType();
            Field[] declaredFields = class2.getDeclaredFields();

            complexType.setFieldName(declaredField.getName());
            complexType.setTypeName(declaredField.getType().getTypeName());
            List<FormField> formFields = new ArrayList<>();
            complexType.setFields(formFields);
            for (Field field : declaredFields) {
                explain(currentValue,field, formFields);
            }
            formFieldList.add(complexType);
        }
    }

    public static boolean isList(String typeName){
        return "java.util.List".equals(typeName) || "java.lang.Arrays".equals(typeName);
    }

    public static String switchToObject(String typeName1,String typeName2){
        if(isList(typeName1)){
            return typeName2;
        }
        return typeName1;
    }
}
