
Vue.component('add-wsdl', {
    template: `
    <el-form ref="form" :model="form" label-width="80px">
      <el-form-item label="项目">
        <el-select v-model="form.projectId" placeholder="请选择活动区域">
          <el-option v-for="project in projectList" :key="project.id" :label="project.name" :value="project.id"></el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="WSDL">
        <el-input v-model="form.wsdl"></el-input>
      </el-form-item>

  <el-form-item>
    <el-button type="primary" @click="onSubmit">立即创建</el-button>
    <el-button>取消</el-button>
  </el-form-item>
</el-form>
    `,
    props: ['isshow'], // html接收字段名都是小写，单向传递
    data() {
        return {
            projectList: [],
            form: {
                wsdl: '',
                projectId: 1
            }
        }
    },
    watch: { // 传值发生改变触发事件
        // isshow: {
        //     handler(newVal, oldVal) {
        //         console.log('isshow旧值:' + oldVal);
        //         console.log('isshow新值:' + newVal);
        //         // 根据值的改变，写相应逻辑代码
        //         this.getInfo();
        //     }
        // },
    },
    created(){
        this.queryProjects();
    },
    methods: { // 组件内方法
        queryProjects(){
            var _this = this;
            $.ajax({
                type: 'POST',
                url: '/query-projects?loadWebservice=false&loadOperation=false',
                contentType:'application/json',
                timeout: 5000,
                data: JSON.stringify({}),
                dataType: "JSON",
                success: function ({code,data}, textStatus, jqXHR) {
                    if(data && code === 0){
                        _this.projectList = data;
                        if(_this.projectList && _this.projectList.length>0){
                            _this.form.projectId = _this.projectList[0].id
                        }
                    }
                },
                error: function (xhrJson,status,error) {

                }
            });
        },
        onSubmit(){
            var _this = this;
            $.ajax({
                type: 'POST',
                url: '/add-webservice',
                contentType:'application/json',
                timeout: 5000,
                data: JSON.stringify({
                    wsdl: _this.form.wsdl,
                    projectId: _this.form.projectId
                }),
                dataType: "JSON",
                success: function ({code,data,msg}, textStatus, jqXHR) {
                    console.log(data)
                    if(code === 0){
                        _this.$message.success(msg);
                        _this.$emit('reload-projects');
                    }else{
                        _this.$message.error(msg);
                    }
                },
                error: function (xhrJson,status,error) {
                    _this.$message.error(error);
                }
            });
        }
    }
})